(document:surround "/std/frame")

;;; Functions
(define (init-iface)
  (form-update-enum "iface" (woo-list "/net-pppoe/avail_iface"))
  (form-update-enum "status" (woo-list "/net-pppoe/avail_state")))

(define (read-current-iface)
  (read-iface (or (form-value "name") "")))

(define (read-iface name)
  (catch/message
    (lambda()
      (let ((data (woo-read-first "/net-pppoe/" 'name name)))

	(form-update-enum "name" (woo-list "/net-pppoe/avail_connection"))
	(form-update-value "password" "")
	(form-update-value-list '("name"
				  "new_name"
				  "info"
				  "status"
				  "iface"
				  "login"
				  "mppe")
				data)))))

(define (write-iface)
  (catch/message
    (lambda()
      (apply woo-write "/net-pppoe" 'commit #t (form-value-list))
      (read-iface (form-value "name")))))

(define (new-iface)
  (catch/message
    (lambda()
      (let ((new_name (form-value "new_name")))
	(woo-write "/net-pppoe" 'new #t 'new_name new_name)
	(read-iface new_name)))))

(define (delete-iface)
  (catch/message
    (lambda()
      (woo-write "/net-pppoe/" 'delete #t 'name (or (form-value "name") ""))
      (read-iface ""))))

;;; UI

(edit visibility #f name "new_name")
(gridbox 
  columns "100"
  margin 10

  (button text (_ "New connection...") align "left" name "new_button")
  (separator)

  (splitbox 
    columns "30;70"
    (listbox name "name")
    (gridbox 
      columns "0;100"
      ;;
      (label text (_ "Status:") align "right")
      (hbox align "left"
	    (label name "info")
	    (combobox name "status"))
      ;;
      (label text (_ "Interface:") align "right" name "iface")
      (combobox name "iface")
      ;;
      (label text (_ "Account:") align "right" name "login")
      (edit name "login")
      ;;
      (label text (_ "Password:") align "right" name "password")
      (edit echo "stars" name "password")
      ;;
      (spacer)
      (checkbox text (_ "MPPE encryption") name "mppe")
      ;;
      (label colspan 2)
      ;;
      (spacer)
      (hbox
	align "left"
	  (button text (_ "Apply") name "apply_button")
	  (button text (_ "Reset") name "reset_button")
	(label text "    ")
	(button text (_ "Delete connection") name "del_button")))))

;;; Logic
(document:root (when loaded
		 (form-bind "new_button" "click" new-iface)
		 (form-bind "del_button" "click" delete-iface)

		 (form-bind "apply_button" "click" write-iface)
		 (form-bind "reset_button" "click" read-current-iface)
		 (form-bind "name" "change" read-current-iface)

		 (init-iface)
		 (read-current-iface)))

